diff -Naur lopster-1.2.2/src/global.c lopster-new/src/global.c
--- lopster-1.2.2/src/global.c	Sun Aug 29 11:33:38 2004
+++ lopster-new/src/global.c	Thu Oct  7 05:06:01 2004
@@ -525,12 +525,20 @@
     return MEDIA_AUDIO;
   else if (!g_strcasecmp(suffix, "au"))
     return MEDIA_AUDIO;
+  else if (!g_strcasecmp(suffix, "aiff"))
+    return MEDIA_AUDIO;
   else if (!g_strcasecmp(suffix, "ogg"))
 #ifdef HAVE_OGG
     return MEDIA_MP3;
 #else
     return MEDIA_AUDIO;
 #endif
+  else if (!g_strcasecmp(suffix, "flac"))
+    return MEDIA_MP3;
+  else if (!g_strcasecmp(suffix, "m4a"))
+    return MEDIA_MP3;
+  else if (!g_strcasecmp(suffix, "wma"))
+    return MEDIA_MP3;
   else if (!g_strcasecmp(suffix, "mpg"))
     return MEDIA_VIDEO;
   else if (!g_strcasecmp(suffix, "mpeg"))
@@ -547,6 +555,8 @@
     return MEDIA_VIDEO;
   else if (!g_strcasecmp(suffix, "wmf"))
     return MEDIA_VIDEO;
+  else if (!g_strcasecmp(suffix, "wmv"))
+    return MEDIA_VIDEO;
   else if (!g_strcasecmp(suffix, "bmp"))
     return MEDIA_IMAGE;
   else if (!g_strcasecmp(suffix, "png"))
@@ -591,6 +601,18 @@
     return MEDIA_APPLICATION;
   else if (!g_strcasecmp(suffix, "rpm"))
     return MEDIA_APPLICATION;
+  else if (!g_strcasecmp(suffix, "hqx"))
+    return MEDIA_APPLICATION;
+  else if (!g_strcasecmp(suffix, "sit"))
+    return MEDIA_APPLICATION;
+  else if (!g_strcasecmp(suffix, "sitx"))
+    return MEDIA_APPLICATION;
+  else if (!g_strcasecmp(suffix, "dmg"))
+    return MEDIA_APPLICATION;
+  else if (!g_strcasecmp(suffix, "img"))
+    return MEDIA_APPLICATION;
+  else if (!g_strcasecmp(suffix, "toast"))
+    return MEDIA_APPLICATION;
   else
     return MEDIA_NONE;
 }
@@ -3462,7 +3484,7 @@
   global.options.resume_timeout = 60;
   global.options.check_lib_for_download = 1;
   global.options.time_display = 0;
-  global.options.browser = g_strdup("dillo %s");
+  global.options.browser = g_strdup("launch -l '%s'");
   global.options.filetips = 1;
 
   global.options.down_speed[0] = SPEED_RED;
@@ -3481,7 +3503,7 @@
   global.options.graph_mode[1] = 2;
   global.options.graph_show[0] = 2;
   global.options.graph_show[1] = 2;
-  global.options.ping_search=0;
+  global.options.ping_search=1;
   global.options.search_show_folder=1;
   global.options.max_chat_buffer = 30;
   global.options.switch_im = 1;
@@ -3545,7 +3567,7 @@
   global.allowed_ports = NULL;
 
   global.auto_save = NULL;
-  global.ping_command = g_strdup("/bin/ping -c 3 $IP");
+  global.ping_command = g_strdup("/sbin/ping -c 3 $IP");
 
   global.browse_width[0] = 369;
   global.browse_width[1] = 80;
diff -Naur lopster-1.2.2/src/mtypes.c lopster-new/src/mtypes.c
--- lopster-1.2.2/src/mtypes.c	Sat Jul  3 08:19:20 2004
+++ lopster-new/src/mtypes.c	Thu Oct  7 05:06:01 2004
@@ -125,8 +125,7 @@
   //////////////////////////////////////////////////////////////
   mtype = &MType[MEDIA_MP3];
   
-  mtype->app = g_list_append(mtype->app, app_new("xmms %f", "Open"));
-  mtype->app = g_list_append(mtype->app, app_new("xmms -e %f", "Enqueue"));
+  mtype->app = g_list_append(mtype->app, app_new("open '%f'", "Open"));
   mtype->suffix = 
     g_list_append(mtype->suffix, suffix_new("mp3"));
 #ifdef HAVE_OGG
@@ -137,7 +136,7 @@
   //////////////////////////////////////////////////////////////
   mtype = &MType[MEDIA_VIDEO];
   
-  mtype->app = g_list_append(mtype->app, app_new("mplayer %f", "MPlayer"));
+  mtype->app = g_list_append(mtype->app, app_new("open '%f'", "Open"));
   mtype->suffix = 
     g_list_append(mtype->suffix, suffix_new("mpg mpeg"));
   mtype->suffix = 
@@ -150,7 +149,7 @@
   //////////////////////////////////////////////////////////////
   mtype = &MType[MEDIA_IMAGE];
   
-  mtype->app = g_list_append(mtype->app, app_new("ee %f", "Electric eyes"));
+  mtype->app = g_list_append(mtype->app, app_new("open '%f'", "Open"));
   mtype->suffix = 
     g_list_append(mtype->suffix, suffix_new("jpg jpeg"));
   mtype->suffix = 
@@ -163,8 +162,7 @@
   //////////////////////////////////////////////////////////////
   mtype = &MType[MEDIA_FOLDER];
   
-  mtype->app = g_list_append(mtype->app, app_new("gmc %f", "Browse"));
-  mtype->app = g_list_append(mtype->app, app_new("xmms %f", "Xmms"));
+  mtype->app = g_list_append(mtype->app, app_new("open `dirname '%f'`", "Browse"));
 }
 */
 
diff -Naur lopster-1.2.2/src/wizard.c lopster-new/src/wizard.c
--- lopster-1.2.2/src/wizard.c	Sat Jul  3 08:19:21 2004
+++ lopster-new/src/wizard.c	Thu Oct  7 05:08:39 2004
@@ -978,7 +978,7 @@
   ww.page3_entry[0] = entry;
 #ifdef HAVE_OGG
 # ifdef HAVE_FLAC
-  gtk_entry_set_text (GTK_ENTRY (entry), "mp3 ogg flac");
+  gtk_entry_set_text (GTK_ENTRY (entry), "mp3 ogg flac m4a wma");
 # else
   gtk_entry_set_text (GTK_ENTRY (entry), "mp3 ogg");
 # endif // HAVE_FLAC
@@ -996,7 +996,7 @@
                     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                     (GtkAttachOptions) (0), 0, 0);
   ww.page3_entry[1] = entry;
-  gtk_entry_set_text(GTK_ENTRY(entry), "\"mpg mpeg\" avi asf mov wmf \"rm ram\"");
+  gtk_entry_set_text(GTK_ENTRY(entry), "\"mpg mpeg\" avi asf mov wmf wmv \"rm ram\"");
 
   entry = gtk_entry_new ();
   gtk_widget_show (entry);
@@ -1006,7 +1006,7 @@
   ww.page3_entry[2] = entry;
 #ifdef HAVE_OGG
 # ifdef HAVE_FLAC
-  gtk_entry_set_text(GTK_ENTRY(entry), "wav au");
+  gtk_entry_set_text(GTK_ENTRY(entry), "wav au aiff");
 # else
   gtk_entry_set_text(GTK_ENTRY(entry), "wav au flac");
 # endif
@@ -1024,7 +1024,7 @@
                     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                     (GtkAttachOptions) (0), 0, 0);
   ww.page3_entry[3] = entry;
-  gtk_entry_set_text(GTK_ENTRY(entry), "tgz tar gz exe bz2 zip rpm dep dll");
+  gtk_entry_set_text(GTK_ENTRY(entry), "tgz tar gz exe bz2 zip rpm deb dll hqx sit sitx dmg img toast");
 
   entry = gtk_entry_new ();
   gtk_widget_show (entry);