diff -ruN nessus-plugins.orig/Makefile nessus-plugins/Makefile
--- nessus-plugins.orig/Makefile	2003-12-11 15:23:25.000000000 -0500
+++ nessus-plugins/Makefile	2012-02-09 07:43:56.000000000 -0500
@@ -10,10 +10,10 @@
 
 install-updater :
 	test -d $(DESTDIR)${sbindir} || $(INSTALL_DIR) -m 755 $(DESTDIR)${sbindir}
-	$(INSTALL) -o $(installuser) -m 0555 nessus-update-plugins \
+	$(INSTALL) -m 0555 nessus-update-plugins \
 		$(DESTDIR)${sbindir}
 	@test -d $(DESTDIR)${mandir}/man8 || $(INSTALL_DIR) $(DESTDIR)${mandir}/man8
-	$(INSTALL) -o $(installuser) -m 0444 docs/nessus-update-plugins.8 \
+	$(INSTALL) -m 0444 docs/nessus-update-plugins.8 \
 		$(DESTDIR)${mandir}/man8
 
 install-dirs:
@@ -24,19 +24,19 @@
 	
 install-nasl:	install-dirs
 	for scripts in scripts/*.nasl; do \
-	$(INSTALL) -o $(installuser) -m 444 $$scripts \
+	$(INSTALL) -m 444 $$scripts \
 		$(DESTDIR)${libdir}/nessus/plugins; \
 	done
 
 install-inc: install-dirs
 	for scripts in scripts/*.inc; do \
-	$(INSTALL) -o $(installuser) -m 444 $$scripts \
+	$(INSTALL) -m 444 $$scripts \
 		$(DESTDIR)${libdir}/nessus/plugins; \
 	done
 
 install-nes: install-dirs
 	for plugins in bin/*.nes; do \
-	$(INSTALL) -o $(installuser) -m 555 $$plugins \
+	$(INSTALL) -m 555 $$plugins \
 		$(DESTDIR)${libdir}/nessus/plugins; \
 	done
 
diff -ruN nessus-plugins.orig/configure nessus-plugins/configure
--- nessus-plugins.orig/configure	2004-12-10 13:38:33.000000000 -0500
+++ nessus-plugins/configure	2012-02-09 07:43:29.000000000 -0500
@@ -3419,7 +3419,7 @@
     # FIXME: Relying on posixy $() will cause problems for
     #        cross-compilation, but unfortunately the echo tests do not
     #        yet detect zsh echo's removal of \ escapes.
-    archive_cmds='$nonopt $(test "x$module" = xyes && echo -bundle || echo -dynamiclib) $allow_undefined_flag -o $lib $libobjs $deplibs$linker_flags -install_name $rpath/$soname $verstring'
+    archive_cmds='$nonopt $(test "x$module" = xyes && echo -bundle || echo -dynamiclib) $allow_undefined_flag -o $lib $libobjs $deplibs$linker_flags $(test "x$module" != xyes && echo -install_name $rpath/$soname $verstring)'
     # We need to add '_' to the symbols in $export_symbols first
     #archive_expsym_cmds="$archive_cmds"' && strip -s $export_symbols'
     hardcode_direct=yes
diff -ruN nessus-plugins.orig/plugins/3com_hub/Makefile.darwin nessus-plugins/plugins/3com_hub/Makefile.darwin
--- nessus-plugins.orig/plugins/3com_hub/Makefile.darwin	Sun Jun  9 05:06:53 2002
+++ nessus-plugins/plugins/3com_hub/Makefile.darwin	Mon Apr 14 10:35:53 2003
@@ -2,12 +2,13 @@
 
 PLUGNAME=3com_hub
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+INCS = `libnet-config --defines --cflags` -I@PREFIX@/include 
+LD_ADDS = `libnet-config --defines --libs`
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/darwin.inc nessus-plugins/plugins/darwin.inc
--- nessus-plugins.orig/plugins/darwin.inc	Wed Dec 31 17:00:00 1969
+++ nessus-plugins/plugins/darwin.inc	Mon Apr 14 11:13:15 2003
@@ -0,0 +1,23 @@
+LTCOMPILE = $(LIBTOOL) --mode=compile $(CC) $(DEFS) $(include)
+LINK = $(LIBTOOL) --mode=link $(CC) \
+	-flat_namespace -undefined suppress \
+	$(DEFS) $(LDFLAGS) -o $@
+
+la_LDFLAGS = -bundle -avoid-version
+
+.SUFFIXES: .c .lo .o
+
+.c.o: 
+	$(CC) $(DEFS) $(include) $(INCS) $(LIBNET_INC) -c $<
+
+.c.lo:
+	$(LTCOMPILE) $(INCS) $(LIBNET_INC) -c $<
+
+$(PLUGNAME).nes: $(LO_OBJS)
+	$(LINK) -rpath $(prefix)/bin/plugins $(la_LDFLAGS) \
+	$(LD_ADDS) $(LIBUTIL) $(LO_OBJS) $(LIBS)
+	../install_plug $(PLUGNAME) $(rootdir)
+
+clean:
+	@rm -fr *.lo *.nes *.la .libs
+	@rm -fr *.o
diff -ruN nessus-plugins.orig/plugins/find_service/Makefile.darwin nessus-plugins/plugins/find_service/Makefile.darwin
--- nessus-plugins.orig/plugins/find_service/Makefile.darwin	Wed Nov  7 13:28:34 2001
+++ nessus-plugins/plugins/find_service/Makefile.darwin	Mon Apr 14 10:07:31 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=find_service
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/ftp_write_dirs/Makefile.darwin nessus-plugins/plugins/ftp_write_dirs/Makefile.darwin
--- nessus-plugins.orig/plugins/ftp_write_dirs/Makefile.darwin	Wed Nov  7 13:28:34 2001
+++ nessus-plugins/plugins/ftp_write_dirs/Makefile.darwin	Mon Apr 14 10:07:54 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=ftp_write_dirs
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/install_plug nessus-plugins/plugins/install_plug
--- nessus-plugins.orig/plugins/install_plug	Tue Oct 16 14:47:12 2001
+++ nessus-plugins/plugins/install_plug	Mon Apr 14 09:29:05 2003
@@ -28,10 +28,9 @@
 cp .libs/$1.so.0.0.0 $2/bin/$1.nes
 cp .libs/lib$1.so.0.0.0 $1.nes
 else
-if [ -f .libs/lib$1.0.0.0.dylib ]; then 		# Darwin
+if [ -f ./$1.nes ]; then 		# Darwin
 test -d $2/bin || mkdir $2/bin
-cp .libs/lib$1.0.0.0.dylib $2/bin/$1.nes
-cp .libs/lib$1.0.0.0.dylib $1.nes
+cp ./$1.nes $2/bin/$1.nes
 fi
 fi
 fi
diff -ruN nessus-plugins.orig/plugins/linux_tftp/Makefile.darwin nessus-plugins/plugins/linux_tftp/Makefile.darwin
--- nessus-plugins.orig/plugins/linux_tftp/Makefile.darwin	Wed Nov  7 13:28:34 2001
+++ nessus-plugins/plugins/linux_tftp/Makefile.darwin	Mon Apr 14 10:08:21 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=linux_tftp
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/nikto_wrapper/Makefile.darwin nessus-plugins/plugins/nikto_wrapper/Makefile.darwin
--- nessus-plugins.orig/plugins/nikto_wrapper/Makefile.darwin	Fri Feb 15 05:29:23 2002
+++ nessus-plugins/plugins/nikto_wrapper/Makefile.darwin	Mon Apr 14 10:08:57 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=nikto_wrapper
 
-all : $(PLUGNAME).nes 
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o  $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/nmap_tcp_connect/Makefile.darwin nessus-plugins/plugins/nmap_tcp_connect/Makefile.darwin
--- nessus-plugins.orig/plugins/nmap_tcp_connect/Makefile.darwin	Wed Nov  7 13:28:34 2001
+++ nessus-plugins/plugins/nmap_tcp_connect/Makefile.darwin	Mon Apr 14 10:09:25 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=nmap_tcp_connect
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/nmap_wrapper/Makefile.darwin nessus-plugins/plugins/nmap_wrapper/Makefile.darwin
--- nessus-plugins.orig/plugins/nmap_wrapper/Makefile.darwin	Mon Feb  4 13:47:10 2002
+++ nessus-plugins/plugins/nmap_wrapper/Makefile.darwin	Mon Apr 14 10:09:35 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=nmap_wrapper
 
-all : $(PLUGNAME).nes 
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o  $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/objectserver/Makefile.darwin nessus-plugins/plugins/objectserver/Makefile.darwin
--- nessus-plugins.orig/plugins/objectserver/Makefile.darwin	Wed Nov  7 13:28:35 2001
+++ nessus-plugins/plugins/objectserver/Makefile.darwin	Mon Apr 14 10:09:45 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=objectserver
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o  $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/smad/Makefile.darwin nessus-plugins/plugins/smad/Makefile.darwin
--- nessus-plugins.orig/plugins/smad/Makefile.darwin	Wed Nov  7 13:28:35 2001
+++ nessus-plugins/plugins/smad/Makefile.darwin	Mon Apr 14 10:09:53 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=smad
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/snmp_portscan/Makefile.darwin nessus-plugins/plugins/snmp_portscan/Makefile.darwin
--- nessus-plugins.orig/plugins/snmp_portscan/Makefile.darwin	Tue Feb  5 07:42:47 2002
+++ nessus-plugins/plugins/snmp_portscan/Makefile.darwin	Mon Apr 14 10:10:00 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=snmp_portscan
 
-all : $(PLUGNAME).nes 
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o  $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/ssl_ciphers/Makefile.darwin nessus-plugins/plugins/ssl_ciphers/Makefile.darwin
--- nessus-plugins.orig/plugins/ssl_ciphers/Makefile.darwin	Fri Feb  8 13:31:29 2002
+++ nessus-plugins/plugins/ssl_ciphers/Makefile.darwin	Mon Apr 14 10:10:11 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=ssl_ciphers
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/synscan/Makefile.darwin nessus-plugins/plugins/synscan/Makefile.darwin
--- nessus-plugins.orig/plugins/synscan/Makefile.darwin	Wed Feb  5 20:27:20 2003
+++ nessus-plugins/plugins/synscan/Makefile.darwin	Mon Apr 14 10:10:20 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=synscan
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc
diff -ruN nessus-plugins.orig/plugins/tftp_grab_file/Makefile.darwin nessus-plugins/plugins/tftp_grab_file/Makefile.darwin
--- nessus-plugins.orig/plugins/tftp_grab_file/Makefile.darwin	Wed Nov  7 13:28:35 2001
+++ nessus-plugins/plugins/tftp_grab_file/Makefile.darwin	Mon Apr 14 10:10:31 2003
@@ -2,12 +2,10 @@
 
 PLUGNAME=tftp_grab_file
 
-all : $(PLUGNAME).nes
-$(PLUGNAME).nes : $(PLUGNAME).c
-	$(CC) -bundle -undefined error $(DEFS) $(include) -c  $(PLUGNAME).c
-	$(CC) -bundle -undefined error -o $(PLUGNAME).nes $(PLUGNAME).o $(LIBS)
-	cp $(PLUGNAME).nes $(rootdir)/bin/
-clean :
-	@rm -fr *.lo *.nes *.la .libs
-	@rm -fr *.o
+all: $(PLUGNAME).nes
 
+OBJS = $(PLUGNAME).o
+
+LO_OBJS = $(PLUGNAME).lo
+
+include ../darwin.inc